#ifndef fsample_HEADER_
#define fsample_HEADER_

#include "soundconfig.h"

// A floating point sample. 
typedef struct {
    int    len;  // The number of samples in each channel.
    float *L;    // The left channel.
    float *R;    // The right channel.
} FSample;

// Load a sample. Allocates.
void fsample_load(FSample *s, char *path, SoundConfig *conf, int buf_size);
void fsample_set_data(FSample *s, float *L, float *R, int len);
double fsample_max_amp(FSample *s);

// Free a sample.
void fsample_free(FSample *s);


#endif
